from Products.Archetypes.atapi import BaseSchema, Schema
from Products.Archetypes.atapi import SelectionWidget
from Products.Archetypes.atapi import RichWidget
from Products.Archetypes.atapi import BaseContent
from Products.Archetypes.atapi import registerType
from Products.Archetypes.atapi import *

from Products.CMFDynamicViewFTI.interface import ISelectableBrowserDefault

from Products.CMFCore import permissions

from Products.ContentCaller.config import PROJECTNAME

from zope.interface import implements

schema = BaseSchema.copy() +  Schema((
    StringField('gwtPath', required=True, widget = StringWidget(label = 'Path to GWT .js'),),
    StringField('gwtContentSlotId', required=True, defult="gwtSlot", widget = StringWidget(label = 'Slot Id'),),
    ))

class GWTPage(BaseContent):
  implements(ISelectableBrowserDefault)
  """ An Archetype for an ExternalPage application """
  schema = schema
  meta_type = portal_type = 'GWTPage'
  archetype_name = 'GWT Page'  
  _at_rename_after_creation = True  
  
  def canSetDefaultPage(self):
      return False
  
  def canSetLayout(self):
      return False
  
  actions = ({
        'id'          : 'view',
        'name'        : 'View',
        'action'      : 'string:${object_url}',
        'permissions' : (permissions.View,)
         },
        {
        'id'          : 'edit',
        'name'        : 'Edit',
        'action'      : 'string:${object_url}/edit',
        'permissions' : (permissions.ModifyPortalContent,),
         },
        {
        'id'          : 'metadata',
        'name'        : 'Properties',
        'action'      : 'string:${object_url}/properties',
        'permissions' : (permissions.ModifyPortalContent,),
         },
        )
  
  aliases = {
        '(Default)'  : 'gwtpage_view',
        'view'       : 'gwtpage_view',
        'edit'       : 'base_edit',
        'properties' : 'base_metadata',
        }  

registerType(GWTPage, PROJECTNAME)    