from Products.Archetypes.atapi import BaseSchema, Schema
from Products.Archetypes.atapi import SelectionWidget
from Products.Archetypes.atapi import RichWidget
from Products.Archetypes.atapi import BaseContent
from Products.Archetypes.atapi import registerType
from Products.Archetypes.atapi import *

from Products.CMFDynamicViewFTI.interface import ISelectableBrowserDefault

from Products.CMFCore import permissions

from Products.ContentCaller.config import PROJECTNAME

from zope.interface import implements


# 
schema = BaseSchema.copy() +  Schema((
     StringField('iFramePath', required=True, widget = StringWidget(label = 'External URL'),),                                     
     StringField('iFrameWidth', widget = StringWidget(label = 'Width of the IFrame'),),
     StringField('iFrameHeight', widget = StringWidget(label = 'Height of the IFrame'),),
    ))

class IFramePage(BaseContent):
    
  implements(ISelectableBrowserDefault)
  """ An Archetype for an ExternalPage application """
  schema = schema
  meta_type = portal_type = 'IFramePage'
  archetype_name = 'IFrame Page'  
  _at_rename_after_creation = True
  
  def canSetDefaultPage(self):
      return False
  
  def canSetLayout(self):
      return False
  
  actions = ({
        'id'          : 'view',
        'name'        : 'View',
        'action'      : 'string:${object_url}',
        'permissions' : (permissions.View,)
         },
        {
        'id'          : 'edit',
        'name'        : 'Edit',
        'action'      : 'string:${object_url}/edit',
        'permissions' : (permissions.ModifyPortalContent,),
         },
        {
        'id'          : 'metadata',
        'name'        : 'Properties',
        'action'      : 'string:${object_url}/properties',
        'permissions' : (permissions.ModifyPortalContent,),
         },
        )
  
  aliases = {
        '(Default)'  : 'iframepage_view',
        'view'       : 'iframepage_view',
        'edit'       : 'base_edit',
        'properties' : 'base_metadata',
        }  

registerType(IFramePage, PROJECTNAME)    